import sourcemaps from 'rollup-plugin-sourcemaps';

export default {
  input: 'lib/index.js',
  plugins: [sourcemaps()],
  external: [
    '@preserves/core',
    '@syndicate-lang/core',
    '@syndicate-lang/html',
    '@syndicate-lang/ws-relay',
  ],
  output: {
    file: 'index.js',
    format: 'umd',
    name: 'Main',
    sourcemap: true,
    globals: {
      '@preserves/core': 'Preserves',
      '@syndicate-lang/core': 'Syndicate',
      '@syndicate-lang/html': 'SyndicateHtml',
      '@syndicate-lang/ws-relay': 'SyndicateWsRelay',
    },
  },
};
